/*
  rdesktop: A Remote Desktop Protocol client.
  Amiga front-end etc
  Copyright (C) Martin Blom 2004-2005
            (C) Michal Zukowski 2013-2018
*/	

#include "show_disconnect_reason.h"
void show_disconnect_reason(uint16 reason)
{
	char *text;

	switch (reason)
	{
		case ERRINFO_NO_INFO:
			text = "No information available";
			break;

		case ERRINFO_RPC_INITIATED_DISCONNECT:
			text = "Server initiated disconnect";
			break;

		case ERRINFO_RPC_INITIATED_LOGOFF:
			text = "Server initiated logoff";
			break;

		case ERRINFO_IDLE_TIMEOUT:
			text = "Server idle timeout reached";
			break;

		case ERRINFO_LOGON_TIMEOUT:
			text = "Server logon timeout reached";
			break;

		case ERRINFO_DISCONNECTED_BY_OTHERCONNECTION:
			text = "The session was replaced";
			break;

		case ERRINFO_OUT_OF_MEMORY:
			text = "The server is out of memory";
			break;

		case ERRINFO_SERVER_DENIED_CONNECTION:
			text = "The server denied the connection";
			break;

		case ERRINFO_SERVER_DENIED_CONNECTION_FIPS:
			text = "The server denied the connection for security reason";
			break;

		case ERRINFO_LICENSE_INTERNAL:
			text = "Internal licensing error";
			break;

		case ERRINFO_LICENSE_NO_LICENSE_SERVER:
			text = "No license server available";
			break;

		case ERRINFO_LICENSE_NO_LICENSE:
			text = "No valid license available";
			break;

		case ERRINFO_LICENSE_BAD_CLIENT_MSG:
			text = "Invalid licensing message";
			break;

		case ERRINFO_LICENSE_HWID_DOESNT_MATCH_LICENSE:
			text = "Hardware id doesn't match software license";
			break;

		case ERRINFO_LICENSE_BAD_CLIENT_LICENSE:
			text = "Client license error";
			break;

		case ERRINFO_LICENSE_CANT_FINISH_PROTOCOL:
			text = "Network error during licensing protocol";
			break;

		case ERRINFO_LICENSE_CLIENT_ENDED_PROTOCOL:
			text = "Licensing protocol was not completed";
			break;

		case ERRINFO_LICENSE_BAD_CLIENT_ENCRYPTION:
			text = "Incorrect client license enryption";
			break;

		case ERRINFO_LICENSE_CANT_UPGRADE_LICENSE:
			text = "Can't upgrade license";
			break;

		case ERRINFO_LICENSE_NO_REMOTE_CONNECTIONS:
			text = "The server is not licensed to accept remote connections";
			break;

		default:
			if (reason > 0x1000 && reason < 0x7fff)
			{
				text = "Internal protocol error";
			}
			else
			{
				text = "Unknown reason";
			}
	}
	error("disconnect: %s.\n", text);
}
